def batch_norm(input: Tensor,
    running_mean: Optional[Tensor],
    running_var: Optional[Tensor],
    weight: Optional[Tensor]=None,
    bias: Optional[Tensor]=None,
    training: bool=False,
    momentum: float=0.10000000000000001,
    eps: float=1.0000000000000001e-05) -> Tensor:
  _0 = __torch__.torch.nn.functional._verify_batch_size
  if training:
    _1 = _0(torch.size(input), )
  else:
    pass
  _2 = torch.batch_norm(input, weight, bias, running_mean, running_var, training, momentum, eps, True)
  return _2
def silu(input: Tensor,
    inplace: bool=False) -> Tensor:
  if inplace:
    _3 = torch.silu_(input)
  else:
    _3 = torch.silu(input)
  return _3
def _max_pool2d(input: Tensor,
    kernel_size: List[int],
    stride: Optional[List[int]]=None,
    padding: List[int]=[0, 0],
    dilation: List[int]=[1, 1],
    ceil_mode: bool=False,
    return_indices: bool=False) -> Tensor:
  if torch.__is__(stride, None):
    stride0 = annotate(List[int], [])
  else:
    stride0 = unchecked_cast(List[int], stride)
  _4 = torch.max_pool2d(input, kernel_size, stride0, padding, dilation, ceil_mode)
  return _4
def binary_cross_entropy(input: Tensor,
    target: Tensor,
    weight: Optional[Tensor]=None,
    size_average: Optional[bool]=None,
    reduce: Optional[bool]=None,
    reduction: str="mean") -> Tensor:
  _5 = __torch__.torch.nn._reduction.legacy_get_enum
  _6 = __torch__.torch.nn._reduction.get_enum
  _7 = "Using a target size ({}) that is different to the input size ({}) is deprecated. Please ensure they have the same size."
  if torch.__isnot__(size_average, None):
    _8, size_average0 = True, unchecked_cast(bool, size_average)
  else:
    _8, size_average0 = torch.__isnot__(reduce, None), size_average
  if _8:
    reduction_enum = _5(size_average0, reduce, True, )
  else:
    reduction_enum = _6(reduction, )
  _9 = torch.ne(torch.size(target), torch.size(input))
  if _9:
    _10 = torch.format(_7, torch.size(target), torch.size(input))
    ops.prim.RaiseException(_10, "builtins.ValueError")
  else:
    pass
  if torch.__isnot__(weight, None):
    weight1 = unchecked_cast(Tensor, weight)
    new_size = torch._infer_size(torch.size(target), torch.size(weight1))
    weight0 : Optional[Tensor] = torch.expand(weight1, new_size)
  else:
    weight0 = weight
  _11 = torch.binary_cross_entropy(input, target, weight0, reduction_enum)
  return _11
def l1_loss(input: Tensor,
    target: Tensor,
    size_average: Optional[bool]=None,
    reduce: Optional[bool]=None,
    reduction: str="mean") -> Tensor:
  _12 = "Using a target size ({}) that is different to the input size ({}). This will likely lead to incorrect results due to broadcasting. Please ensure they have the same size."
  _13 = __torch__.torch.nn._reduction.legacy_get_string
  _14 = __torch__.torch.nn._reduction.get_enum
  _15 = torch.eq(torch.size(target), torch.size(input))
  if torch.__not__(_15):
    _16 = torch.format(_12, torch.size(target), torch.size(input))
    torch.warn(_16)
  else:
    pass
  if torch.__isnot__(size_average, None):
    _17, size_average1 = True, unchecked_cast(bool, size_average)
  else:
    _17, size_average1 = torch.__isnot__(reduce, None), size_average
  if _17:
    reduction0 = _13(size_average1, reduce, True, )
  else:
    reduction0 = reduction
  _18 = torch.broadcast_tensors([input, target])
  expanded_input, expanded_target, = _18
  _19 = torch.l1_loss(expanded_input, expanded_target, _14(reduction0, ))
  return _19
def binary_cross_entropy_with_logits(input: Tensor,
    target: Tensor,
    weight: Optional[Tensor]=None,
    size_average: Optional[bool]=None,
    reduce: Optional[bool]=None,
    reduction: str="mean",
    pos_weight: Optional[Tensor]=None) -> Tensor:
  _20 = __torch__.torch.nn._reduction.legacy_get_enum
  _21 = __torch__.torch.nn._reduction.get_enum
  _22 = "Target size ({}) must be the same as input size ({})"
  if torch.__isnot__(size_average, None):
    _23, size_average2 = True, unchecked_cast(bool, size_average)
  else:
    _23, size_average2 = torch.__isnot__(reduce, None), size_average
  if _23:
    reduction_enum = _20(size_average2, reduce, True, )
  else:
    reduction_enum = _21(reduction, )
  _24 = torch.eq(torch.size(target), torch.size(input))
  if torch.__not__(_24):
    _25 = torch.format(_22, torch.size(target), torch.size(input))
    ops.prim.RaiseException(_25, "builtins.ValueError")
  else:
    pass
  _26 = torch.binary_cross_entropy_with_logits(input, target, weight, pos_weight, reduction_enum)
  return _26
def _verify_batch_size(size: List[int]) -> NoneType:
  _27 = "Expected more than 1 value per channel when training, got input size {}"
  size_prods = size[0]
  size_prods0 = size_prods
  for i in range(torch.sub(torch.len(size), 2)):
    size_prods1 = torch.mul(size_prods0, size[torch.add(i, 2)])
    size_prods0 = size_prods1
  if torch.eq(size_prods0, 1):
    ops.prim.RaiseException(torch.format(_27, size), "builtins.ValueError")
  else:
    pass
  return None
def adaptive_avg_pool2d(input: Tensor,
    output_size: List[int]) -> Tensor:
  _28 = torch.gt(torch.len(torch.size(input)), torch.len(output_size))
  if _28:
    pass
  else:
    ops.prim.RaiseException("AssertionError: ")
  _29 = torch.adaptive_avg_pool2d(input, output_size)
  return _29
def adaptive_avg_pool3d(input: Tensor,
    output_size: List[int]) -> Tensor:
  _30 = torch.gt(torch.len(torch.size(input)), torch.len(output_size))
  if _30:
    pass
  else:
    ops.prim.RaiseException("AssertionError: ")
  _31 = torch.adaptive_avg_pool3d(input, output_size)
  return _31
