class Focus(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  conv : __torch__.yolox.models.network_blocks.BaseConv
  def forward(self: __torch__.yolox.models.network_blocks.Focus,
    x: Tensor) -> Tensor:
    patch_top_left = torch.slice(torch.slice(x, -2, None, None, 2), -1, None, None, 2)
    patch_top_right = torch.slice(torch.slice(x, -2, None, None, 2), -1, 1, None, 2)
    patch_bot_left = torch.slice(torch.slice(x, -2, 1, None, 2), -1, None, None, 2)
    patch_bot_right = torch.slice(torch.slice(x, -2, 1, None, 2), -1, 1, None, 2)
    _0 = [patch_top_left, patch_bot_left, patch_top_right, patch_bot_right]
    x0 = torch.cat(_0, 1)
    conv = self.conv
    return (conv).forward(x0, )
class BaseConv(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  conv : __torch__.torch.nn.modules.conv.Conv2d
  bn : __torch__.torch.nn.modules.batchnorm.BatchNorm2d
  act : __torch__.torch.nn.modules.activation.SiLU
  def forward(self: __torch__.yolox.models.network_blocks.BaseConv,
    x: Tensor) -> Tensor:
    act = self.act
    bn = self.bn
    conv = self.conv
    _1 = (act).forward((bn).forward((conv).forward(x, ), ), )
    return _1
class CSPLayer(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  conv1 : __torch__.yolox.models.network_blocks.___torch_mangle_4.BaseConv
  conv2 : __torch__.yolox.models.network_blocks.___torch_mangle_4.BaseConv
  conv3 : __torch__.yolox.models.network_blocks.___torch_mangle_6.BaseConv
  m : __torch__.torch.nn.modules.container.Sequential
  def forward(self: __torch__.yolox.models.network_blocks.CSPLayer,
    x: Tensor) -> Tensor:
    conv1 = self.conv1
    x_1 = (conv1).forward(x, )
    conv2 = self.conv2
    x_2 = (conv2).forward(x, )
    m = self.m
    x_10 = (m).forward(x_1, )
    x1 = torch.cat([x_10, x_2], 1)
    conv3 = self.conv3
    return (conv3).forward(x1, )
class Bottleneck(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  use_add : bool
  conv1 : __torch__.yolox.models.network_blocks.___torch_mangle_8.BaseConv
  conv2 : __torch__.yolox.models.network_blocks.___torch_mangle_10.BaseConv
  def forward(self: __torch__.yolox.models.network_blocks.Bottleneck,
    x: Tensor) -> Tensor:
    conv2 = self.conv2
    conv1 = self.conv1
    y = (conv2).forward((conv1).forward(x, ), )
    use_add = self.use_add
    if use_add:
      y0 = torch.add(y, x)
    else:
      y0 = y
    return y0
class SPPBottleneck(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  conv1 : __torch__.yolox.models.network_blocks.___torch_mangle_42.BaseConv
  m : __torch__.torch.nn.modules.container.ModuleList
  conv2 : __torch__.yolox.models.network_blocks.___torch_mangle_46.BaseConv
  def forward(self: __torch__.yolox.models.network_blocks.SPPBottleneck,
    x: Tensor) -> Tensor:
    conv1 = self.conv1
    x2 = (conv1).forward(x, )
    _2 = [x2]
    _3 = annotate(List[Tensor], [])
    m = self.m
    _0 = getattr(m, "0")
    _1 = getattr(m, "1")
    _20 = getattr(m, "2")
    _4 = torch.append(_3, (_0).forward(x2, ))
    _5 = torch.append(_3, (_1).forward(x2, ))
    _6 = torch.append(_3, (_20).forward(x2, ))
    x3 = torch.cat(torch.add(_2, _3), 1)
    conv2 = self.conv2
    return (conv2).forward(x3, )
