class YOLOXHead(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  n_anchors : int
  reg_weight : float
  num_classes : int
  decode_in_inference : bool
  use_l1 : bool
  strides : List[int]
  grids : List[Tensor]
  cls_convs : __torch__.torch.nn.modules.container.___torch_mangle_69.ModuleList
  reg_convs : __torch__.torch.nn.modules.container.___torch_mangle_69.ModuleList
  cls_preds : __torch__.torch.nn.modules.container.___torch_mangle_71.ModuleList
  reg_preds : __torch__.torch.nn.modules.container.___torch_mangle_73.ModuleList
  obj_preds : __torch__.torch.nn.modules.container.___torch_mangle_75.ModuleList
  stems : __torch__.torch.nn.modules.container.___torch_mangle_76.ModuleList
  l1_loss : __torch__.torch.nn.modules.loss.L1Loss
  bcewithlog_loss : __torch__.torch.nn.modules.loss.BCEWithLogitsLoss
  iou_loss : __torch__.yolox.models.losses.IOUloss
  def forward(self: __torch__.yolox.models.yolo_head.YOLOXHead,
    xin: Tuple[Tensor, Tensor, Tensor],
    labels: Tensor=CONSTANTS.c0,
    imgs: Tensor=CONSTANTS.c0) -> Tuple[Tensor, Tuple[Tensor, Tensor, Tensor, Tensor, Tensor, float]]:
    _0 = annotate(List[Tensor], [])
    _1 = annotate(List[Tensor], [])
    _2 = annotate(List[Tensor], [])
    _3 = annotate(List[Tensor], [])
    _4 = annotate(List[Tensor], [])
    cls_convs = self.cls_convs
    _00 = getattr(cls_convs, "0")
    _10 = getattr(cls_convs, "1")
    _20 = getattr(cls_convs, "2")
    reg_convs = self.reg_convs
    _01 = getattr(reg_convs, "0")
    _11 = getattr(reg_convs, "1")
    _21 = getattr(reg_convs, "2")
    stems = self.stems
    _02 = getattr(stems, "0")
    _12 = getattr(stems, "1")
    _22 = getattr(stems, "2")
    reg_preds = self.reg_preds
    _03 = getattr(reg_preds, "0")
    _13 = getattr(reg_preds, "1")
    _23 = getattr(reg_preds, "2")
    cls_preds = self.cls_preds
    _04 = getattr(cls_preds, "0")
    _14 = getattr(cls_preds, "1")
    _24 = getattr(cls_preds, "2")
    obj_preds = self.obj_preds
    _05 = getattr(obj_preds, "0")
    _15 = getattr(obj_preds, "1")
    _25 = getattr(obj_preds, "2")
    strides = self.strides
    stride_this_level = strides[0]
    x = (xin)[0]
    x0 = (_02).forward(x, )
    cls_feat = (_00).forward(x0, )
    cls_output = (_04).forward(cls_feat, )
    reg_feat = (_01).forward(x0, )
    reg_output = (_03).forward(reg_feat, )
    obj_output = (_05).forward(reg_feat, )
    training = self.training
    if training:
      _5 = [reg_output, obj_output, cls_output]
      output0 = torch.cat(_5, 1)
      _6 = (self).get_output_and_grid(output0, 0, stride_this_level, ops.prim.dtype((xin)[0]), )
      output1, grid, = _6
      _7 = torch.select(torch.slice(torch.slice(grid), 1), 2, 0)
      _8 = torch.append(_2, _7)
      _9 = torch.select(torch.slice(torch.slice(grid), 1), 2, 1)
      _16 = torch.append(_3, _9)
      _17 = torch.zeros([1, (torch.size(grid))[1]])
      _18 = torch.fill_(_17, stride_this_level)
      _19 = torch.append(_4, torch.type_as(_18, (xin)[0]))
      use_l1 = self.use_l1
      if use_l1:
        batch_size = (torch.size(reg_output))[0]
        _26 = torch.slice(torch.size(reg_output), -2)
        hsize, wsize, = _26
        n_anchors = self.n_anchors
        _27 = [batch_size, n_anchors, 4, hsize, wsize]
        reg_output0 = torch.view(reg_output, _27)
        _28 = torch.permute(reg_output0, [0, 1, 3, 4, 2])
        reg_output1 = torch.reshape(_28, [batch_size, -1, 4])
        _29 = torch.append(_1, torch.clone(reg_output1))
      else:
        pass
      output = output1
    else:
      _30 = [reg_output, torch.sigmoid(obj_output), torch.sigmoid(cls_output)]
      output = torch.cat(_30, 1)
    _31 = torch.append(_0, output)
    strides0 = self.strides
    stride_this_level0 = strides0[1]
    x1 = (xin)[1]
    x2 = (_12).forward(x1, )
    cls_feat0 = (_10).forward(x2, )
    cls_output0 = (_14).forward(cls_feat0, )
    reg_feat0 = (_11).forward(x2, )
    reg_output2 = (_13).forward(reg_feat0, )
    obj_output0 = (_15).forward(reg_feat0, )
    training0 = self.training
    if training0:
      _32 = [reg_output2, obj_output0, cls_output0]
      output3 = torch.cat(_32, 1)
      _33 = (self).get_output_and_grid(output3, 1, stride_this_level0, ops.prim.dtype((xin)[0]), )
      output4, grid0, = _33
      _34 = torch.slice(torch.slice(grid0), 1)
      _35 = torch.append(_2, torch.select(_34, 2, 0))
      _36 = torch.slice(torch.slice(grid0), 1)
      _37 = torch.append(_3, torch.select(_36, 2, 1))
      _38 = torch.zeros([1, (torch.size(grid0))[1]])
      _39 = torch.fill_(_38, stride_this_level0)
      _40 = torch.append(_4, torch.type_as(_39, (xin)[0]))
      use_l10 = self.use_l1
      if use_l10:
        batch_size0 = (torch.size(reg_output2))[0]
        _41 = torch.slice(torch.size(reg_output2), -2)
        hsize0, wsize0, = _41
        n_anchors0 = self.n_anchors
        _42 = [batch_size0, n_anchors0, 4, hsize0, wsize0]
        reg_output3 = torch.view(reg_output2, _42)
        _43 = torch.permute(reg_output3, [0, 1, 3, 4, 2])
        reg_output4 = torch.reshape(_43, [batch_size0, -1, 4])
        _44 = torch.append(_1, torch.clone(reg_output4))
      else:
        pass
      output2 = output4
    else:
      _45 = [reg_output2, torch.sigmoid(obj_output0), torch.sigmoid(cls_output0)]
      output2 = torch.cat(_45, 1)
    _46 = torch.append(_0, output2)
    strides1 = self.strides
    stride_this_level1 = strides1[2]
    x3 = (xin)[2]
    x4 = (_22).forward(x3, )
    cls_feat1 = (_20).forward(x4, )
    cls_output1 = (_24).forward(cls_feat1, )
    reg_feat1 = (_21).forward(x4, )
    reg_output5 = (_23).forward(reg_feat1, )
    obj_output1 = (_25).forward(reg_feat1, )
    training1 = self.training
    if training1:
      _47 = [reg_output5, obj_output1, cls_output1]
      output6 = torch.cat(_47, 1)
      _48 = (self).get_output_and_grid(output6, 2, stride_this_level1, ops.prim.dtype((xin)[0]), )
      output7, grid1, = _48
      _49 = torch.slice(torch.slice(grid1), 1)
      _50 = torch.append(_2, torch.select(_49, 2, 0))
      _51 = torch.slice(torch.slice(grid1), 1)
      _52 = torch.append(_3, torch.select(_51, 2, 1))
      _53 = torch.zeros([1, (torch.size(grid1))[1]])
      _54 = torch.fill_(_53, stride_this_level1)
      _55 = torch.append(_4, torch.type_as(_54, (xin)[0]))
      use_l11 = self.use_l1
      if use_l11:
        batch_size1 = (torch.size(reg_output5))[0]
        _56 = torch.slice(torch.size(reg_output5), -2)
        hsize1, wsize1, = _56
        n_anchors1 = self.n_anchors
        _57 = [batch_size1, n_anchors1, 4, hsize1, wsize1]
        reg_output6 = torch.view(reg_output5, _57)
        _58 = torch.permute(reg_output6, [0, 1, 3, 4, 2])
        reg_output7 = torch.reshape(_58, [batch_size1, -1, 4])
        _59 = torch.append(_1, torch.clone(reg_output7))
      else:
        pass
      output5 = output7
    else:
      _60 = [reg_output5, torch.sigmoid(obj_output1), torch.sigmoid(cls_output1)]
      output5 = torch.cat(_60, 1)
    _61 = torch.append(_0, output5)
    training2 = self.training
    if training2:
      outputs = torch.cat(_0, 1)
      _63 = (self).get_losses(imgs, _2, _3, _4, labels, outputs, _1, ops.prim.dtype((xin)[0]), )
      _62 = (outputs, _63)
    else:
      hw = annotate(List[List[int]], [])
      for _64 in range(torch.len(_0)):
        x5 = _0[_64]
        _65 = torch.append(hw, torch.slice(torch.size(x5), -2))
      _66 = annotate(List[Tensor], [])
      for _67 in range(torch.len(_0)):
        x6 = _0[_67]
        _68 = torch.append(_66, torch.flatten(x6, 2))
      outputs0 = torch.permute(torch.cat(_66, 2), [0, 2, 1])
      losses = (torch.tensor([0]), torch.tensor([0]), torch.tensor([0]), torch.tensor([0]), torch.tensor([0]), 0.)
      decode_in_inference = self.decode_in_inference
      if decode_in_inference:
        _70 = (self).decode_outputs(outputs0, ops.prim.dtype((xin)[0]), hw, )
        _69 = (_70, losses)
      else:
        _69 = (outputs0, losses)
      _62 = _69
    return _62
  def get_output_and_grid(self: __torch__.yolox.models.yolo_head.YOLOXHead,
    output: Tensor,
    k: int,
    stride: int,
    dtype: int) -> Tuple[Tensor, Tensor]:
    grids = self.grids
    grid = grids[k]
    batch_size = (torch.size(output))[0]
    num_classes = self.num_classes
    n_ch = torch.add(5, num_classes)
    hsize, wsize, = torch.slice(torch.size(output), -2)
    _59 = torch.slice(torch.size(grid), 2, 4)
    _60 = torch.slice(torch.size(output), 2, 4)
    if torch.ne(_59, _60):
      _61 = torch.arange(hsize, dtype=None, layout=None, device=ops.prim.device(output))
      _62 = torch.arange(wsize, dtype=None, layout=None, device=ops.prim.device(output))
      yv, xv, = torch.meshgrid([_61, _62])
      _63 = torch.view(torch.stack([xv, yv], 2), [1, 1, hsize, wsize, 2])
      grid3 = torch.to(_63, dtype)
      grids0 = self.grids
      _64 = torch._set_item(grids0, k, grid3)
      grid2 = grid3
    else:
      grid2 = grid
    n_anchors = self.n_anchors
    _65 = [batch_size, n_anchors, n_ch, hsize, wsize]
    output8 = torch.view(output, _65)
    _66 = torch.permute(output8, [0, 1, 3, 4, 2])
    n_anchors2 = self.n_anchors
    _67 = torch.mul(torch.mul(n_anchors2, hsize), wsize)
    output9 = torch.reshape(_66, [batch_size, _67, -1])
    grid4 = torch.view(grid2, [1, -1, 2])
    _68 = torch.add(torch.slice(output9, -1, None, 2), grid4)
    _69 = torch.mul(_68, stride)
    _70 = torch.copy_(torch.slice(output9, -1, None, 2), _69)
    _71 = torch.exp(torch.slice(output9, -1, 2, 4))
    _72 = torch.mul(_71, stride)
    _73 = torch.copy_(torch.slice(output9, -1, 2, 4), _72)
    return (output9, grid4)
  def get_losses(self: __torch__.yolox.models.yolo_head.YOLOXHead,
    imgs: Tensor,
    x_shifts_list: List[Tensor],
    y_shifts_list: List[Tensor],
    expanded_strides_list: List[Tensor],
    labels: Tensor,
    outputs: Tensor,
    origin_preds_list: List[Tensor],
    dtype: int) -> Tuple[Tensor, Tensor, Tensor, Tensor, Tensor, float]:
    _74 = torch.slice(torch.slice(outputs), 1)
    bbox_preds = torch.slice(_74, 2, None, 4)
    _75 = torch.slice(torch.slice(outputs), 1)
    obj_preds = torch.unsqueeze(torch.select(_75, 2, 4), -1)
    _76 = torch.slice(torch.slice(outputs), 1)
    cls_preds = torch.slice(_76, 2, 5)
    nlabel = torch.sum(torch.gt(torch.sum(labels, [2]), 0), [1])
    total_num_anchors = (torch.size(outputs))[1]
    x_shifts = torch.cat(x_shifts_list, 1)
    y_shifts = torch.cat(y_shifts_list, 1)
    expanded_strides = torch.cat(expanded_strides_list, 1)
    use_l1 = self.use_l1
    if use_l1:
      origin_preds = torch.cat(origin_preds_list, 1)
    else:
      origin_preds = torch.new_zeros(outputs, [0, 4])
    _77 = annotate(List[Tensor], [])
    _78 = annotate(List[Tensor], [])
    _79 = annotate(List[Tensor], [])
    _80 = annotate(List[Tensor], [])
    _81 = annotate(List[Tensor], [])
    num_fg = 0.
    num_gts = 0.
    for batch_idx in range((torch.size(outputs))[0]):
      _82 = torch.select(nlabel, 0, batch_idx)
      num_gt = int(_82)
      num_gts0 = torch.add(num_gts, num_gt)
      if torch.eq(num_gt, 0):
        num_classes = self.num_classes
        cls_target0 = torch.new_zeros(outputs, [0, num_classes])
        reg_target0 = torch.new_zeros(outputs, [0, 4])
        l1_target0 = torch.new_zeros(outputs, [0, 4])
        obj_target0 = torch.new_zeros(outputs, [total_num_anchors, 1])
        _83 = torch.new_zeros(outputs, [total_num_anchors])
        cls_target, reg_target, obj_target, fg_mask, l1_target, num_fg0 = cls_target0, reg_target0, obj_target0, torch.to(_83, 11), l1_target0, num_fg
      else:
        _84 = torch.select(labels, 0, batch_idx)
        _85 = torch.slice(_84, 0, None, num_gt)
        gt_bboxes_per_image = torch.slice(_85, 1, 1, 5)
        _86 = torch.select(labels, 0, batch_idx)
        _87 = torch.slice(_86, 0, None, num_gt)
        gt_classes = torch.select(_87, 1, 0)
        bboxes_preds_per_image = torch.select(bbox_preds, 0, batch_idx)
        _88 = (self).get_assignments(batch_idx, num_gt, total_num_anchors, gt_bboxes_per_image, gt_classes, bboxes_preds_per_image, expanded_strides, x_shifts, y_shifts, cls_preds, bbox_preds, obj_preds, labels, imgs, "gpu", )
        gt_matched_classes, fg_mask0, pred_ious_this_matching, matched_gt_inds, num_fg_img, = _88
        num_fg1 = torch.add(num_fg, num_fg_img)
        _89 = torch.to(gt_matched_classes, 4)
        num_classes0 = self.num_classes
        _90 = torch.one_hot(_89, num_classes0)
        _91 = torch.unsqueeze(pred_ious_this_matching, -1)
        cls_target1 = torch.mul(_90, _91)
        obj_target1 = torch.unsqueeze(fg_mask0, -1)
        _92 = annotate(List[Optional[Tensor]], [matched_gt_inds])
        reg_target1 = torch.index(gt_bboxes_per_image, _92)
        use_l12 = self.use_l1
        if use_l12:
          _93 = torch.new_zeros(outputs, [num_fg_img, 4])
          _94 = annotate(List[Optional[Tensor]], [matched_gt_inds])
          _95 = torch.index(gt_bboxes_per_image, _94)
          _96 = torch.select(expanded_strides, 0, 0)
          _97 = annotate(List[Optional[Tensor]], [fg_mask0])
          _98 = torch.index(_96, _97)
          _99 = torch.select(x_shifts, 0, 0)
          _100 = annotate(List[Optional[Tensor]], [fg_mask0])
          _101 = torch.index(_99, _100)
          _102 = torch.select(y_shifts, 0, 0)
          _103 = annotate(List[Optional[Tensor]], [fg_mask0])
          l1_target2 = (self).get_l1_target(_93, _95, _98, _101, torch.index(_102, _103), 1e-08, )
          l1_target1 = l1_target2
        else:
          l1_target3 = torch.new_zeros(outputs, [0, 4])
          l1_target1 = l1_target3
        cls_target, reg_target, obj_target, fg_mask, l1_target, num_fg0 = cls_target1, reg_target1, obj_target1, fg_mask0, l1_target1, num_fg1
      _104 = torch.append(_77, cls_target)
      _105 = torch.append(_78, reg_target)
      _106 = torch.append(_80, torch.to(obj_target, dtype))
      _107 = torch.append(_81, fg_mask)
      use_l13 = self.use_l1
      if use_l13:
        _108 = torch.append(_79, l1_target)
      else:
        pass
      num_fg, num_gts = num_fg0, num_gts0
    cls_targets = torch.cat(_77)
    reg_targets = torch.cat(_78)
    obj_targets = torch.cat(_80)
    fg_masks = torch.cat(_81)
    use_l14 = self.use_l1
    if use_l14:
      l1_targets = torch.cat(_79)
    else:
      l1_targets = torch.new_zeros(outputs, [0, 4])
    num_fg2 = ops.prim.max(num_fg, 1)
    iou_loss = self.iou_loss
    _109 = torch.view(bbox_preds, [-1, 4])
    _110 = annotate(List[Optional[Tensor]], [fg_masks])
    _111 = (iou_loss).forward(torch.index(_109, _110), reg_targets, )
    loss_iou = torch.div(torch.sum(_111), num_fg2)
    bcewithlog_loss = self.bcewithlog_loss
    _112 = (bcewithlog_loss).forward(torch.view(obj_preds, [-1, 1]), obj_targets, )
    loss_obj = torch.div(torch.sum(_112), num_fg2)
    bcewithlog_loss0 = self.bcewithlog_loss
    num_classes1 = self.num_classes
    _113 = torch.view(cls_preds, [-1, num_classes1])
    _114 = annotate(List[Optional[Tensor]], [fg_masks])
    _115 = (bcewithlog_loss0).forward(torch.index(_113, _114), cls_targets, )
    loss_cls = torch.div(torch.sum(_115), num_fg2)
    use_l15 = self.use_l1
    if use_l15:
      l1_loss = self.l1_loss
      _116 = torch.view(origin_preds, [-1, 4])
      _117 = annotate(List[Optional[Tensor]], [fg_masks])
      _118 = (l1_loss).forward(torch.index(_116, _117), l1_targets, )
      loss_l10 = torch.div(torch.sum(_118), num_fg2)
      loss_l1 = loss_l10
    else:
      _119 = ops.prim.device(outputs)
      loss_l11 = torch.full([1], 0., dtype=None, layout=None, device=_119)
      loss_l1 = loss_l11
    reg_weight = self.reg_weight
    _120 = torch.add(torch.mul(loss_iou, reg_weight), loss_obj)
    loss = torch.add(torch.add(_120, loss_cls), loss_l1)
    reg_weight0 = self.reg_weight
    _121 = torch.mul(loss_iou, reg_weight0)
    _122 = torch.div(num_fg2, ops.prim.max(num_gts, 1))
    _123 = (loss, _121, loss_obj, loss_cls, loss_l1, _122)
    return _123
  def get_assignments(self: __torch__.yolox.models.yolo_head.YOLOXHead,
    batch_idx: int,
    num_gt: int,
    total_num_anchors: int,
    gt_bboxes_per_image: Tensor,
    gt_classes: Tensor,
    bboxes_preds_per_image: Tensor,
    expanded_strides: Tensor,
    x_shifts: Tensor,
    y_shifts: Tensor,
    cls_preds: Tensor,
    bbox_preds: Tensor,
    obj_preds: Tensor,
    labels: Tensor,
    imgs: Tensor,
    mode: str="gpu") -> Tuple[Tensor, Tensor, Tensor, Tensor, int]:
    _124 = "------------CPU Mode for This Batch-------------"
    _125 = __torch__.yolox.utils.boxes.bboxes_iou
    _126 = __torch__.torch.nn.functional.binary_cross_entropy
    if torch.eq(mode, "cpu"):
      print(_124)
      gt_bboxes_per_image1 = torch.to(torch.cpu(gt_bboxes_per_image), 6)
      bboxes_preds_per_image1 = torch.to(torch.cpu(bboxes_preds_per_image), 6)
      gt_classes1 = torch.to(torch.cpu(gt_classes), 6)
      expanded_strides1 = torch.to(torch.cpu(expanded_strides), 6)
      gt_bboxes_per_image0, expanded_strides0, x_shifts0, y_shifts0, bboxes_preds_per_image0, gt_classes0 = gt_bboxes_per_image1, expanded_strides1, torch.cpu(x_shifts), torch.cpu(y_shifts), bboxes_preds_per_image1, gt_classes1
    else:
      gt_bboxes_per_image0, expanded_strides0, x_shifts0, y_shifts0, bboxes_preds_per_image0, gt_classes0 = gt_bboxes_per_image, expanded_strides, x_shifts, y_shifts, bboxes_preds_per_image, gt_classes
    _127 = (self).get_in_boxes_info(gt_bboxes_per_image0, expanded_strides0, x_shifts0, y_shifts0, total_num_anchors, num_gt, )
    fg_mask, is_in_boxes_and_center, = _127
    npa = torch.item(torch.sum(fg_mask))
    if torch.eq(npa, 0):
      _128 = True
    else:
      _128 = torch.eq(num_gt, 0)
    if _128:
      _130 = ops.prim.device(fg_mask)
      _131 = torch.zeros([0], dtype=None, layout=None, device=_130)
      gt_matched_classes = torch.to(_131, 4)
      _132 = ops.prim.device(fg_mask)
      pred_ious_this_matching = torch.rand([0], dtype=None, layout=None, device=_132)
      if torch.eq(mode, "cpu"):
        gt_matched_classes1 = torch.cuda(gt_matched_classes)
        fg_mask2 = torch.cuda(fg_mask)
        pred_ious_this_matching1 = torch.cuda(pred_ious_this_matching)
        gt_matched_classes0, fg_mask1, pred_ious_this_matching0, matched_gt_inds = gt_matched_classes1, fg_mask2, pred_ious_this_matching1, torch.cuda(gt_matched_classes)
      else:
        gt_matched_classes0, fg_mask1, pred_ious_this_matching0, matched_gt_inds = gt_matched_classes, fg_mask, pred_ious_this_matching, gt_matched_classes
      _133 = (gt_matched_classes0, fg_mask1, pred_ious_this_matching0, matched_gt_inds, 0)
      _129 = _133
    else:
      _134 = annotate(List[Optional[Tensor]], [torch.clone(fg_mask)])
      bboxes_preds_per_image2 = torch.index(bboxes_preds_per_image0, _134)
      _135 = torch.select(cls_preds, 0, batch_idx)
      _136 = annotate(List[Optional[Tensor]], [torch.clone(fg_mask)])
      cls_preds_ = torch.index(_135, _136)
      _137 = torch.select(obj_preds, 0, batch_idx)
      _138 = annotate(List[Optional[Tensor]], [torch.clone(fg_mask)])
      obj_preds_ = torch.index(_137, _138)
      _139 = torch.size(bboxes_preds_per_image2)
      num_in_boxes_anchor = _139[0]
      if torch.eq(mode, "cpu"):
        gt_bboxes_per_image3 = torch.cpu(gt_bboxes_per_image0)
        bboxes_preds_per_image4 = torch.cpu(bboxes_preds_per_image2)
        gt_bboxes_per_image2, bboxes_preds_per_image3 = gt_bboxes_per_image3, bboxes_preds_per_image4
      else:
        gt_bboxes_per_image2, bboxes_preds_per_image3 = gt_bboxes_per_image0, bboxes_preds_per_image2
      pair_wise_ious = _125(gt_bboxes_per_image2, bboxes_preds_per_image3, False, )
      _140 = torch.to(gt_classes0, 4)
      num_classes = self.num_classes
      _141 = torch.to(torch.one_hot(_140, num_classes), 6)
      gt_cls_per_image = torch.repeat(torch.unsqueeze(_141, 1), [1, num_in_boxes_anchor, 1])
      _142 = torch.log(torch.add(pair_wise_ious, 1e-08))
      pair_wise_ious_loss = torch.neg(_142)
      if torch.eq(mode, "cpu"):
        cls_preds_0, obj_preds_0 = torch.cpu(cls_preds_), torch.cpu(obj_preds_)
      else:
        cls_preds_0, obj_preds_0 = cls_preds_, obj_preds_
      _143 = torch.unsqueeze(torch.to(cls_preds_0, 6), 0)
      _144 = torch.repeat(_143, [num_gt, 1, 1])
      _145 = torch.sigmoid_(_144)
      _146 = torch.unsqueeze(torch.to(obj_preds_0, 6), 0)
      _147 = torch.repeat(_146, [num_gt, 1, 1])
      cls_preds_1 = torch.mul(_145, torch.sigmoid_(_147))
      _148 = _126(torch.sqrt_(cls_preds_1), gt_cls_per_image, None, None, None, "none", )
      pair_wise_cls_loss = torch.sum(_148, [-1])
      _149 = torch.mul(pair_wise_ious_loss, 3.)
      _150 = torch.add(pair_wise_cls_loss, _149)
      _151 = torch.bitwise_not(is_in_boxes_and_center)
      cost = torch.add(_150, torch.mul(_151, 100000.))
      _152 = (self).dynamic_k_matching(cost, pair_wise_ious, gt_classes0, num_gt, fg_mask, )
      num_fg, fg_mask3, gt_matched_classes2, pred_ious_this_matching2, matched_gt_inds0, = _152
      if torch.eq(mode, "cpu"):
        gt_matched_classes4 = torch.cuda(gt_matched_classes2)
        fg_mask5 = torch.cuda(fg_mask3)
        pred_ious_this_matching4 = torch.cuda(pred_ious_this_matching2)
        gt_matched_classes3, fg_mask4, pred_ious_this_matching3, matched_gt_inds1 = gt_matched_classes4, fg_mask5, pred_ious_this_matching4, torch.cuda(matched_gt_inds0)
      else:
        gt_matched_classes3, fg_mask4, pred_ious_this_matching3, matched_gt_inds1 = gt_matched_classes2, fg_mask3, pred_ious_this_matching2, matched_gt_inds0
      _153 = (gt_matched_classes3, fg_mask4, pred_ious_this_matching3, matched_gt_inds1, num_fg)
      _129 = _153
    return _129
  def get_in_boxes_info(self: __torch__.yolox.models.yolo_head.YOLOXHead,
    gt_bboxes_per_image: Tensor,
    expanded_strides: Tensor,
    x_shifts: Tensor,
    y_shifts: Tensor,
    total_num_anchors: int,
    num_gt: int) -> Tuple[Tensor, Tensor]:
    expanded_strides_per_image = torch.select(expanded_strides, 0, 0)
    x_shifts_per_image = torch.mul(torch.select(x_shifts, 0, 0), expanded_strides_per_image)
    y_shifts_per_image = torch.mul(torch.select(y_shifts, 0, 0), expanded_strides_per_image)
    _154 = torch.mul(expanded_strides_per_image, 0.5)
    _155 = torch.unsqueeze(torch.add(x_shifts_per_image, _154), 0)
    x_centers_per_image = torch.repeat(_155, [num_gt, 1])
    _156 = torch.mul(expanded_strides_per_image, 0.5)
    _157 = torch.unsqueeze(torch.add(y_shifts_per_image, _156), 0)
    y_centers_per_image = torch.repeat(_157, [num_gt, 1])
    _158 = torch.select(torch.slice(gt_bboxes_per_image), 1, 0)
    _159 = torch.select(torch.slice(gt_bboxes_per_image), 1, 2)
    _160 = torch.sub(_158, torch.mul(_159, 0.5))
    gt_bboxes_per_image_l = torch.repeat(torch.unsqueeze(_160, 1), [1, total_num_anchors])
    _161 = torch.select(torch.slice(gt_bboxes_per_image), 1, 0)
    _162 = torch.select(torch.slice(gt_bboxes_per_image), 1, 2)
    _163 = torch.add(_161, torch.mul(_162, 0.5))
    gt_bboxes_per_image_r = torch.repeat(torch.unsqueeze(_163, 1), [1, total_num_anchors])
    _164 = torch.select(torch.slice(gt_bboxes_per_image), 1, 1)
    _165 = torch.select(torch.slice(gt_bboxes_per_image), 1, 3)
    _166 = torch.sub(_164, torch.mul(_165, 0.5))
    gt_bboxes_per_image_t = torch.repeat(torch.unsqueeze(_166, 1), [1, total_num_anchors])
    _167 = torch.select(torch.slice(gt_bboxes_per_image), 1, 1)
    _168 = torch.select(torch.slice(gt_bboxes_per_image), 1, 3)
    _169 = torch.add(_167, torch.mul(_168, 0.5))
    gt_bboxes_per_image_b = torch.repeat(torch.unsqueeze(_169, 1), [1, total_num_anchors])
    b_l = torch.sub(x_centers_per_image, gt_bboxes_per_image_l)
    b_r = torch.sub(gt_bboxes_per_image_r, x_centers_per_image)
    b_t = torch.sub(y_centers_per_image, gt_bboxes_per_image_t)
    b_b = torch.sub(gt_bboxes_per_image_b, y_centers_per_image)
    bbox_deltas = torch.stack([b_l, b_t, b_r, b_b], 2)
    _170, _171 = torch.min(bbox_deltas, -1)
    is_in_boxes = torch.gt(_170, 0.)
    is_in_boxes_all = torch.gt(torch.sum(is_in_boxes, [0]), 0)
    _172 = torch.select(torch.slice(gt_bboxes_per_image), 1, 0)
    _173 = torch.repeat(torch.unsqueeze(_172, 1), [1, total_num_anchors])
    _174 = torch.unsqueeze(expanded_strides_per_image, 0)
    gt_bboxes_per_image_l0 = torch.sub(_173, torch.mul(_174, 2.5))
    _175 = torch.select(torch.slice(gt_bboxes_per_image), 1, 0)
    _176 = torch.repeat(torch.unsqueeze(_175, 1), [1, total_num_anchors])
    _177 = torch.unsqueeze(expanded_strides_per_image, 0)
    gt_bboxes_per_image_r0 = torch.add(_176, torch.mul(_177, 2.5))
    _178 = torch.select(torch.slice(gt_bboxes_per_image), 1, 1)
    _179 = torch.repeat(torch.unsqueeze(_178, 1), [1, total_num_anchors])
    _180 = torch.unsqueeze(expanded_strides_per_image, 0)
    gt_bboxes_per_image_t0 = torch.sub(_179, torch.mul(_180, 2.5))
    _181 = torch.select(torch.slice(gt_bboxes_per_image), 1, 1)
    _182 = torch.repeat(torch.unsqueeze(_181, 1), [1, total_num_anchors])
    _183 = torch.unsqueeze(expanded_strides_per_image, 0)
    gt_bboxes_per_image_b0 = torch.add(_182, torch.mul(_183, 2.5))
    c_l = torch.sub(x_centers_per_image, gt_bboxes_per_image_l0)
    c_r = torch.sub(gt_bboxes_per_image_r0, x_centers_per_image)
    c_t = torch.sub(y_centers_per_image, gt_bboxes_per_image_t0)
    c_b = torch.sub(gt_bboxes_per_image_b0, y_centers_per_image)
    center_deltas = torch.stack([c_l, c_t, c_r, c_b], 2)
    _184, _185 = torch.min(center_deltas, -1)
    is_in_centers = torch.gt(_184, 0.)
    is_in_centers_all = torch.gt(torch.sum(is_in_centers, [0]), 0)
    is_in_boxes_anchor = torch.__or__(is_in_boxes_all, is_in_centers_all)
    _186 = torch.slice(is_in_boxes)
    _187 = annotate(List[Optional[Tensor]], [None, is_in_boxes_anchor])
    _188 = torch.index(_186, _187)
    _189 = torch.slice(is_in_centers)
    _190 = annotate(List[Optional[Tensor]], [None, is_in_boxes_anchor])
    is_in_boxes_and_center = torch.__and__(_188, torch.index(_189, _190))
    _191 = (is_in_boxes_anchor, is_in_boxes_and_center)
    return _191
  def dynamic_k_matching(self: __torch__.yolox.models.yolo_head.YOLOXHead,
    cost: Tensor,
    pair_wise_ious: Tensor,
    gt_classes: Tensor,
    num_gt: int,
    fg_mask: Tensor) -> Tuple[int, Tensor, Tensor, Tensor, Tensor]:
    matching_matrix = torch.zeros_like(cost, dtype=0)
    n_candidate_k = ops.prim.min(10, torch.size(pair_wise_ious, 1))
    topk_ious, _192 = torch.topk(pair_wise_ious, n_candidate_k, 1)
    _193 = torch.to(torch.sum(topk_ious, [1]), 3)
    dynamic_ks = torch.clamp(_193, 1)
    pos_idx = torch.zeros([0])
    _194 = _192
    pos_idx0 = pos_idx
    _195 = 0
    _196 = torch.gt(num_gt, 0)
    while _196:
      _197 = torch.ge(_195, torch.size(dynamic_ks, 0))
      if _197:
        _198, _199 = _194, pos_idx0
      else:
        _200 = torch.select(cost, 0, _195)
        _201 = torch.select(dynamic_ks, 0, _195)
        _202, pos_idx1 = torch.topk(_200, int(torch.item(_201)), -1, False)
        _203 = torch.select(matching_matrix, 0, _195)
        _204 = torch.tensor(1, dtype=ops.prim.dtype(_203), device=ops.prim.device(_203))
        _205 = annotate(List[Optional[Tensor]], [pos_idx1])
        _206 = torch.index_put_(_203, _205, _204)
        _198, _199 = _202, pos_idx1
      _207 = torch.add(_195, 1)
      _208 = torch.__and__(torch.lt(_207, num_gt), True)
      _196, _194, pos_idx0, _195 = _208, _198, _199, _207
    anchor_matching_gt = torch.sum(matching_matrix, [0])
    _209 = torch.sum(torch.gt(anchor_matching_gt, 1))
    if bool(torch.gt(_209, 0)):
      _210 = torch.gt(anchor_matching_gt, 1)
      _211 = torch.slice(cost)
      _212 = annotate(List[Optional[Tensor]], [None, _210])
      _213, cost_argmin = torch.min(torch.index(_211, _212), 0)
      _214 = torch.gt(anchor_matching_gt, 1)
      _215 = torch.slice(matching_matrix)
      _216 = annotate(List[Optional[Tensor]], [None, _214])
      _217 = torch.mul_(torch.index(_215, _216), 0)
      _218 = torch.index_put_(_215, _216, _217)
      _219 = torch.gt(anchor_matching_gt, 1)
      _220 = torch.tensor(1, dtype=ops.prim.dtype(matching_matrix), device=ops.prim.device(matching_matrix))
      _221 = annotate(List[Optional[Tensor]], [cost_argmin, _219])
      _222 = torch.index_put_(matching_matrix, _221, _220)
    else:
      pass
    fg_mask_inboxes = torch.gt(torch.sum(matching_matrix, [0]), 0)
    _223 = torch.item(torch.sum(fg_mask_inboxes))
    num_fg = int(_223)
    _224 = annotate(List[Optional[Tensor]], [torch.clone(fg_mask)])
    _225 = torch.index_put_(fg_mask, _224, fg_mask_inboxes)
    _226 = torch.slice(matching_matrix)
    _227 = annotate(List[Optional[Tensor]], [None, fg_mask_inboxes])
    matched_gt_inds = torch.argmax(torch.index(_226, _227), 0)
    _228 = annotate(List[Optional[Tensor]], [matched_gt_inds])
    gt_matched_classes = torch.index(gt_classes, _228)
    _229 = torch.mul(matching_matrix, pair_wise_ious)
    _230 = torch.sum(_229, [0])
    _231 = annotate(List[Optional[Tensor]], [fg_mask_inboxes])
    pred_ious_this_matching = torch.index(_230, _231)
    _232 = (num_fg, fg_mask, gt_matched_classes, pred_ious_this_matching, matched_gt_inds)
    return _232
  def get_l1_target(self: __torch__.yolox.models.yolo_head.YOLOXHead,
    l1_target: Tensor,
    gt: Tensor,
    stride: Tensor,
    x_shifts: Tensor,
    y_shifts: Tensor,
    eps: float=1e-08) -> Tensor:
    _233 = torch.div(torch.select(torch.slice(gt), 1, 0), stride)
    _234 = torch.sub(_233, x_shifts)
    _235 = torch.select(torch.slice(l1_target), 1, 0)
    _236 = torch.copy_(_235, _234)
    _237 = torch.div(torch.select(torch.slice(gt), 1, 1), stride)
    _238 = torch.sub(_237, y_shifts)
    _239 = torch.select(torch.slice(l1_target), 1, 1)
    _240 = torch.copy_(_239, _238)
    _241 = torch.div(torch.select(torch.slice(gt), 1, 2), stride)
    _242 = torch.log(torch.add(_241, eps))
    _243 = torch.select(torch.slice(l1_target), 1, 2)
    _244 = torch.copy_(_243, _242)
    _245 = torch.div(torch.select(torch.slice(gt), 1, 3), stride)
    _246 = torch.log(torch.add(_245, eps))
    _247 = torch.select(torch.slice(l1_target), 1, 3)
    _248 = torch.copy_(_247, _246)
    return l1_target
  def decode_outputs(self: __torch__.yolox.models.yolo_head.YOLOXHead,
    outputs: Tensor,
    dtype: int,
    hw: List[List[int]]) -> Tensor:
    _249 = annotate(List[Tensor], [])
    _250 = annotate(List[Tensor], [])
    strides = self.strides
    _251 = ops.prim.min([torch.len(hw), torch.len(strides)])
    for _252 in range(_251):
      _253 = hw[_252]
      stride = strides[_252]
      hsize, wsize, = _253
      _254 = torch.arange(hsize, dtype=None, layout=None, device=ops.prim.device(outputs))
      _255 = torch.arange(wsize, dtype=None, layout=None, device=ops.prim.device(outputs))
      yv, xv, = torch.meshgrid([_254, _255])
      grid = torch.view(torch.stack([xv, yv], 2), [1, -1, 2])
      _256 = torch.append(_249, grid)
      shape = torch.slice(torch.size(grid), None, 2)
      _257 = shape[0]
      _258 = shape[1]
      _259 = ops.prim.device(outputs)
      _260 = torch.full([_257, _258, 1], stride, dtype=None, layout=None, device=_259)
      _261 = torch.append(_250, _260)
    grids = torch.to(torch.cat(_249, 1), dtype)
    strides2 = torch.to(torch.cat(_250, 1), dtype)
    _262 = torch.add(torch.slice(outputs, -1, None, 2), grids)
    _263 = torch.mul(_262, strides2)
    _264 = torch.copy_(torch.slice(outputs, -1, None, 2), _263)
    _265 = torch.exp(torch.slice(outputs, -1, 2, 4))
    _266 = torch.mul(_265, strides2)
    _267 = torch.copy_(torch.slice(outputs, -1, 2, 4), _266)
    return outputs
